<template>
  <div>
    <div class="cluster-list">
      <div v-if="isLoading" class="cluster-list__loader">
        <ob-loader
            :width="10"
            :height="10"
            :duration="2"
            class="cluster-list__loader-icon"
        />
      </div>

      <div class="baseprices-clustering-groups"
           v-for="(direction) in directions"
           :key="direction.uuid ? direction.uuid : direction.locationUuid">
        <ObAccordion
            :title="direction.title"
            :isOpen="false"
            :icon="getAccordionIcon"
        >
          <template v-slot:title-content>
            <div class="accordion-title-item" v-if="filterData.viewMode === 'intracity'">
              <template v-if="direction.locationUuid">
                <div class="accordion-title-item__city">
                  {{ getLocationTitleFromUuid(direction.locationUuid) }}
                  <span class="all-directions"> внутригородские перевозки </span>
                </div>

              </template>
            </div>
            <div class="accordion-title-item" v-else-if="filterData.viewMode === 'container'">
              <template>
                <div class="accordion-title-item__city">
                  <i class="icon" :class="[direction.categoryFrom === 'AGGLOMERATION' ? 'aglomeration' : 'city-sm']"></i>
                  {{ getAgglomerationTitle(direction.clusterFromUuid, direction.categoryFrom) }}
                </div>
                <div class="accordion-title-item__divider">→</div>
                <div class="accordion-title-item__city">
                  <i class="icon" :class="[direction.categoryTo === 'AGGLOMERATION' ? 'aglomeration' : 'city-sm']"></i>
                  {{ getAgglomerationTitle(direction.clusterToUuid, direction.categoryTo) }}
                </div>
                <div class="compatible_stations" @click.stop="openCompatibleModal(direction)">
                  <i class="icon train-sm"></i>Совместимые станции: {{ direction.compatibleCount }}
                </div>
              </template>
            </div>
            <div class="accordion-title-item" v-else>
              <template v-if="direction.locationFromUuid && direction.locationToUuid">
                <div class="accordion-title-item__city">
                  <i class="icon" :class="getLocationIconFromUuid(direction.locationFromUuid)"></i> {{ getLocationTitleFromUuid(direction.locationFromUuid) }}
                </div>
                <div class="accordion-title-item__divider">→</div>
                <div class="accordion-title-item__city">
                  <i class="icon" :class="getLocationIconFromUuid(direction.locationToUuid)"></i> {{ getLocationTitleFromUuid(direction.locationToUuid) }}
                </div>
                <div class="accordion-title-item__distance">{{ direction.distance }} км</div>
              </template>
              <template v-else>
                <div class="all-directions"> Группировка «₽/км» по всем направлениям кластера </div>
              </template>
            </div>
          </template>

          <div class="baseprices-clustering-acc-content">
            <MonitorTable
              :groupBy="(filterData.viewMode !== 'container' ? 'group' : '')"
              :columns="columns"
              :items="direction.contentClustersResources"
              :loading="isLoading"
              dataQa="tableContentClustersResourcesBP"
              :direction="direction"
              @update="loadData"
              @openExpertPriceModal="openExpertPriceModal"
              @toggleRow="toggleRow"
              :viewMode="filterData.viewMode"
              :showHeader="true"
            ></MonitorTable>

<!--            <MonitorTable-->
<!--              v-if="direction.contentWRWhere && direction.contentWRWhere.length"-->
<!--              groupBy="group"-->
<!--              :columns="columns"-->
<!--              :items="direction.contentWRWhere"-->
<!--              :loading="isLoading"-->
<!--              dataQa="tableContentClustersWRWhereBP"-->
<!--              :direction="direction"-->
<!--              @update="loadData"-->
<!--              @openExpertPriceModal="openExpertPriceModal"-->
<!--              @toggleRow="toggleRow"-->
<!--              :viewMode="filterData.viewMode"-->
<!--              :hideHeader="true"-->
<!--            ></MonitorTable>-->


<!--            <MonitorTable-->
<!--              v-if="direction.contentWRWithoutGeograhy && direction.contentWRWithoutGeograhy.length"-->
<!--              groupBy="group"-->
<!--              :columns="columns"-->
<!--              :items="direction.contentWRWithoutGeograhy"-->
<!--              :loading="isLoading"-->
<!--              dataQa="tableContentWRWithoutGeograhyBP"-->
<!--              :direction="direction"-->
<!--              @update="loadData"-->
<!--              @openExpertPriceModal="openExpertPriceModal"-->
<!--              @toggleRow="toggleRow"-->
<!--              :viewMode="filterData.viewMode"-->
<!--              :hideHeader="true"-->
<!--            ></MonitorTable>-->
          </div>

        </ObAccordion>
      </div>

      <div class="table-footer">
        <div v-if="pagination.totalElements" class="total-count"> Всего: {{ pagination.totalElements }}</div>
        <ObPagination
            :page="pagination.pageNum"
            :count="pagination.totalElements"
            :page-limit="pagination.pageSize"
            :is-wide="true"
            @on-change="clickPage"
        />
      </div>
    </div>

    <ObModal
      ref="ClusterExpertPriceModalForm"
      title="Экспертный тариф"
      size="medium"
      @closed="modalClosed()"
      data-qa="modalClusterExpertPriceBP"
    >
      <ClusterExpertPriceModal
        :data-source="selectedData"
        :service="selectedServiceData"
        @save="onExpertPriceSave"
      />
    </ObModal>

    <ObModal
      ref="compatibleStationsModal"
      title="Совместимые станции"
      size="large"
      data-qa="compatibleStationsModalBP"
      :is-show-controls="true"
      :is-read-only="true"
      @closed="onCompatibleStationsModalClose"
    >
      <CompatibleStationsModal
        :dataSource="compatibleStationsData"
      />
    </ObModal>

  </div>
</template>

<script>
import api from '@/api';
import ObPagination from 'common-components/src/obComponents/obPagination';
import ObLoader from 'common-components/src/obComponents/obLoader';
import ObModal from 'common-components/src/obComponents/obModal';
import ObAccordion from '@/pages/basePricesClustering/components/accordion';
import ClusterExpertPriceModal from './modal/ClusterExpertPriceModal';
import CompatibleStationsModal from './modal/compatibleStationsModal';
import { getServiceIcon } from '@/constants/order';
import columns from './columns';
import MonitorTable from './table';
import numberWithSpaces from '@/utils/formatNumber';
import {mapActions, mapGetters} from "vuex";

export default {
  name: 'ClusterBasePriceTable',
  components: {
    ObLoader,
    ObAccordion,
    ObPagination,
    ObModal,
    ClusterExpertPriceModal,
    CompatibleStationsModal,
    MonitorTable,
  },
  props: {
    filterData: {
      type: Object,
      default: () => ({}),
    },
  },
  watch: {
    filterData: {
      handler() {
        if(
            (this.filterData.transportationWay === 'FTL' && this.filterData.cluster) ||
            this.filterData.transportationWay === 'CONTAINER' ||
            this.filterData.viewMode === 'intracity'
        ) {
          this.loadData();
        } else {
          this.clearData();
        }
      },
      deep: true,
      immediate: true
    }
  },
  data() {
    return {
      directions: [],
      columns,
      pagination: {
        pageNum: 0,
        pageSize: 30,
        totalElements: 0,
        elementsCount: 0,
        totalPages: 0,
      },
      isLoading: false,
      selectedData: {},
      selectedServiceData: {},
      compatibleStationsData: {},
      agglomerationsList: [],
      openGroups: [],
    };
  },
  computed: {
    ...mapGetters({
      locations: 'base_prices/locations',
      services: 'base_prices/services',
      getLocationTitleFromUuid: 'base_prices/getLocationTitleFromUuid',
      getLocationIconFromUuid: 'base_prices/getLocationIconFromUuid',
    }),
    getAccordionIcon() {
      let icon = '';
      if( this.filterData.viewMode === 'intracity') {
        icon = 'city-sm';
      } else if ( this.filterData.viewMode === 'cluster') {
        icon = 'aglomeration';
      }
      return icon;
    },
  },
  methods: {
    ...mapActions({
      getLocations: 'base_prices/getLocations',
      getServices: 'base_prices/getServices',
    }),
    getServiceIcon,
    async loadData() {
      try {
        this.isLoading = true;
        let data = await this.getRequestData();

        if (data.content && data.content.length) {
          let formatedData = this.formatData(data.content);
          this.directions = formatedData;

          this.pagination.pageNum = data.pageNum ?? 1;
          this.pagination.pageSize = data.pageSize ?? 20;
          this.pagination.totalElements = data.totalElements;

          await this.getLocationsFromData(this.directions);

        } else {
          this.clearData();
        }
        this.isLoading = false;
      } catch (e) {
        console.error(e);
        this.clearData();
        this.isLoading = false;
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      }
    },
    async getRequestData() {
      let data;
      if ( this.filterData.viewMode === 'intracity' ) {
        data = await api.base_prices_intracity.getIntracityPrices( this.filterData.locationFrom.locationUuid, {
          page_size: this.pagination.pageSize,
          page_num: this.pagination.pageNum
        });
      } else if ( this.filterData.viewMode === 'container' ) {
        if ( !this.agglomerationsList.length ) {
          this.agglomerationsList = await api.locations.getRaylwayAgglomerations();
        }

        data = await api.base_prices_clustering.getClusterContainers( {
          clusterFromUuid: this.filterData.agglomerationFrom,
          clusterToUuid: this.filterData.agglomerationTo,
          pageSize: this.pagination.pageSize,
          pageNum: this.pagination.pageNum
        });

      } else {
        if(!this.filterData.cluster) {
          return;
        }
        data = await api.base_prices_clustering.getClusterExpertPrice( {
          direction_group_uuid: this.filterData.cluster,
          location_from_uuid: this.filterData.clusterLocationFrom,
          location_to_uuid: this.filterData.clusterLocationTo,
          page_size: this.pagination.pageSize,
          page_num: this.pagination.pageNum
        });
      }
      return data;
    },
    formatData(data) {
      return data.map((direction) => {
        if (direction.contentClustersResources) {

          direction.contentClustersResources = direction.contentClustersResources.reduce((all, group, index) => {
            let rows = [];

            if(group.contentResources && group.contentResources.length) {
              let groupService = this.services[group.contentResources[0].serviceUuid] || null;
              if(!group.resourcesGroupUuid) {
                group.resourcesGroupUuid = `${group.serviceTypeUuid}_${index}`;
              }
              let groupData = {
                ...group,
                contentResources: group.contentResources,
                groupService,
                group: groupService ? groupService.serviceTypeTitle : 'Не указано',
                title: group.title,
                isGroup: true,
                isOpen: this.openGroups[group.resourcesGroupUuid] ?? false,
                showResource: true,
                key: group.resourcesGroupUuid+'_'+group?.fixedPrice?.priceStage,
              };
              rows.push(groupData);

              group.contentResources.map(resource => {
                let service = this.services[resource.serviceUuid] || null;
                let groupName = service ? service.serviceTypeTitle : 'Не указано';
                if(service) {
                  rows.push({
                    ...resource,
                    service,
                    group: groupName,
                    title: `${service.resourceSpeciesTitle} ${service.resourceSubtypeTitle} ${service.resourcePatternParameter}`,
                    showResource: this.openGroups[group.resourcesGroupUuid] ?? false,
                    resourcesGroupUuid: group.resourcesGroupUuid,
                    key: resource.serviceUuid+'_'+resource?.fixedPrice?.priceStage,
                  });
                }
              });
            }

            return [...all, ...rows];
          }, []);

          // Добавляем в общий список безресурсные услуги, т.к. они приходят отдельно
          let rowWRWhere = this.processWRData(direction?.contentWRWhere, 'Услуги без ресурса (В точке)');
          let rowWRWithoutGeography = this.processWRData(direction?.contentWRWithoutGeograhy, 'Услуги без ресурса (Без привязки к географии)');
          direction.contentClustersResources = direction.contentClustersResources.concat(rowWRWhere, rowWRWithoutGeography);

          return {
            ...direction,
          }
        } else {
          return [];
        }
      });
    },
    processWRData(data, groupName) {
      if(data && data.length) {
        return data.reduce((all, item) => {
          let service = this.services[item.serviceUuid] || null;
          if (service) {
            item.service = service;
            item.group = groupName;
            item.showResource = true;
            item.title = service.serviceTypeTitle;
            return [...all, item];
          } else {
            return [...all];
          }
        }, []);
      }
      return [];
    },
    clearData() {
      this.directions = [];
      this.pagination.totalElements = 0;
      this.openGroups = {};
    },
    clickPage(page) {
      this.pagination.pageNum = page + 1;
      this.loadData();
    },
    openExpertPriceModal(rowData, direction) {
      if(this.filterData.viewMode === 'intracity') {
        return false;
      }
      this.selectedData = {
        priceStage: rowData.expertPrice.priceStage,
        priceKm: rowData.expertPrice.priceKm,
        distance: direction.distance,
        resourcesGroupUuid: rowData.resourcesGroupUuid,
        directionGroupUuid: this.filterData.cluster,
        directionUuid: direction.directionUuid,
        serviceUuid: rowData.serviceUuid ?? null,
        locationFromUuid: direction.locationFromUuid,
        locationToUuid: direction.locationToUuid,
      }

      this.selectedServiceData = {
        directionTitle: direction.title,
        location: direction.locationFromUuid ? this.getLocationTitleFromUuid(direction.locationFromUuid) + ' → '+this.getLocationTitleFromUuid(direction.locationToUuid) : null,
        service: rowData.service,
        serviceTitle: rowData.title,
        serviceTypeUuid: rowData.service? rowData.service.serviceTypeUuid : rowData.serviceTypeUuid,
      }

      this.$refs.ClusterExpertPriceModalForm.show();
    },
    modalClosed() {
      this.$refs.ClusterExpertPriceModalForm.hide();
      this.selectedData = null;
    },
    onExpertPriceSave() {
      this.$refs.ClusterExpertPriceModalForm.hide();
      this.selectedData = null;
      this.loadData();
    },
    async getLocationsFromData(data) {
      let locations = [];
      if(data.length) {
        data.forEach(group => {
          locations.push(group.locationFromUuid);
          locations.push(group.locationToUuid);
          if (group.clusterFromUuid) {
            locations.push(group.clusterFromUuid);
          }
          if (group.clusterToUuid) {
            locations.push(group.clusterToUuid);
          }
        });
        await this.getLocations(locations);
      }
    },
    getRowClass(data) {
      return data.item.showResource ? 'show-item ' + (data.item.isGroup ? 'is-group' : '') : 'hidden';
    },
    toggleRow(direction, group) {
      group.isOpen = !group.isOpen;
      this.openGroups[group.resourcesGroupUuid] = group.isOpen;
      if(direction.contentClustersResources && direction.contentClustersResources.length) {
        direction.contentClustersResources.map((item) => {
          if(item.resourcesGroupUuid === group.resourcesGroupUuid && !item.isGroup) {
            item.showResource = !item.showResource;
          }
        });
      }
    },
    priceFormat(value, divider = 100) {
      return numberWithSpaces(value, divider).replace('.', ',');
    },
    openCompatibleModal(data) {
      this.compatibleStationsData = data;
      this.compatibleStationsData.titleFrom = this.getAgglomerationTitle(data.clusterFromUuid, data.categoryFrom);
      this.compatibleStationsData.titleTo = this.getAgglomerationTitle(data.clusterToUuid, data.categoryTo);
      this.$refs.compatibleStationsModal.show();
    },
    onCompatibleStationsModalClose() {
      this.$refs.compatibleStationsModal.hide();
    },
    getAgglomerationTitle(uuid, type) {
      let title = '';
      if ( this.agglomerationsList.length ) {
        if(type && type === 'AGGLOMERATION') {
          const agglomeration = this.agglomerationsList.find(agg => agg.uuid === uuid);
          if (agglomeration?.title) {
            title = agglomeration.title;
          }
        } else if (type && type === 'REFERENCE_POSITION') {
          title = this.getLocationTitleFromUuid(uuid);
        } else {
          const agglomeration = this.agglomerationsList.find(agg => agg.uuid === uuid);
          if (agglomeration?.title) {
            title = agglomeration.title;
          } else {
            title = this.getLocationTitleFromUuid(uuid);
          }
        }
      }
      return title;
    },
  },
};
</script>

<style lang="scss" scoped>

$cobalt-border: #d3e1f1;
$gray-light: #9da0ac;

@import '~common-components/src/static/css/mixins';

.baseprices-clustering-acc-content{
  margin-left: 55px;
}

.page-controls {
  position: absolute;
  right: 0;
  margin: -40px 35px 0 20px;
  display: flex;
  align-items: center;
  button {
    @include font-mixin(12px, 16px, 500, $blue-700, 1.6px);
    text-transform: uppercase;
  }
}

.all-directions{
  color: $gray-slate;
}

.cluster-list {
  position: relative;

  ul {
    list-style-type: none;
  }
  &-item {
    border-bottom: 1px solid #e5edf9;
    &-info {
      cursor: pointer;
      display: flex;
      background: $light-lavender ;
      color: $blue-dust;
      padding: 14px 14px;
      //  border-bottom: 1px solid $cobalt-border;
      span {
        margin: 0 15px;
      }
      i {
        font-size: 16px;
      }
    }
  }
  &__loader {
    position: absolute;
    background: $background-white;
    opacity: 0.8;
    left: 0;
    bottom: 0;
    width: 100%;
    height: 100%;
    &-icon {
      position: absolute;
      top: calc(50% - 20px);
      left: calc(50% - 20px);
      width: 40px;
      height: 40px;
    }
  }
}

.resource{
  display: flex;
  align-items: center;
  padding-left: 65px;

  .resource__title{
    font-width: 400;
  }

  .resource__icon{
    width: 65px;
    margin-right: 20px;
  }
}

.resource-group{
  position: relative;
  padding-left: 65px;
  cursor: pointer;

  &__title{
    color: $blue-dust;
  }

  &__icon{
      position: absolute;
      top: 50%;
      left: 30px;
      transform: translateY(-50%);
      font-size: 23px;
      color: $blue-dust;
      transition: all 0.2s linear;

      &.closed {
        transform: translateY(-50%) rotate(-90deg);
      }
  }
}


.reliability{
  color: $deep-blue;
  text-align: right;
}

.td-container {
  position: relative;
}
::v-deep {

  .expert {
    cursor: pointer;
  }

  .ob-accordion__title {
    min-height: 60px;
    border-bottom: 1px solid $cobalt-border;
    justify-content: flex-start;
  }

  .ob-accordion__title-text {
    flex-grow: 0;
    color: $blue-dust;
    width: 250px;
    margin-right: 20px;
  }

  .accordion-title-item {
    display: flex;
    align-items: center;
    width: 100%;

    &__city {
      margin-right: 10px;
      color: $blue-dust;

      i {
        margin-right: 10px;
      }
    }

    &__distance {
      color: $gray-slate;
    }

    &__divider {
      margin-right: 10px;
      color: $blue-dust;
    }

    .compatible_stations{
      margin-left: auto;
      color: $blue-dust;
      display: inline-flex;
      align-items: center;

      i{
        margin-right: 10px;
        font-size: 18px;
      }
    }
  }

  .table-data{
    border-collapse: collapse;
    border: 1px solid #E5EDF9;

    * {
      box-sizing: border-box;
    }

    tr > th:first-child{
      padding-left: 35px;
    }

    thead.fixed tr th{
      border-top: 1px solid #fff;
      box-shadow: none;
      border-bottom: 1px solid #D3E1F1;
    }

    tbody{
      & > tr > td{
        border: 1px solid $lavender;
      }

      & > tr > td:nth-child(1){
        border-right: none;
      }

      & > tr > td:nth-child(2){
        border-left: none;
      }

      .td-container{
        min-height: 60px;
      }

    }
    .td-container > div{
      width: 100%;
    }

    .data-row.hidden{
      display: none;
    }
    .is-group{
      background-color: $light-lavender;
    }

    .ob-accordion__content{
      margin-bottom: 10px;
    }

  }

  .intracity-table{
    thead.fixed tr th:nth-child(4) .column-title,
    thead.fixed tr th:nth-child(5) .column-title,
    thead.fixed tr th:nth-child(7) .column-title{
      color: $color-grey-border;
    }
  }
  .conatiner-table{
    thead.fixed tr th:nth-child(5) .column-title{
      color: $color-grey-border;
    }
  }

  .table-footer {
    position: relative;
    display: flex;
    align-items: center;
    justify-content: space-between;
    height: 40px;
    padding: 0 15px;
    text-transform: uppercase;
    font-size: 12px;
    border-top: 1px $lavender solid;
    border-bottom: 1px solid transparent;
    color: $shale-gray;

    .total-count{
      flex-shrink: 0;
      margin-right: 20px;
    }
  }

  .addExpTariff{
    font-size: 12px;
    text-align: right;
    span {
      color: $blue-dust;
    }
  }

}
</style>
